from .insn import *

"""
RV32I U-Type Instruction
"""

class InsnRV32IUType(Insn):
    def __init__(self, params, opcode):
        super().__init__(params)
        self.opcode = opcode

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.insn_imm.eq(Value.as_signed(self.rvfi_insn[12:32] << 12))

        if self.params.csr_misa:
            m.d.comb += self.misa_ok.eq((self.rvfi_csr_misa_rdata & 0) == 0)
            m.d.comb += self.spec_csr_misa_rmask.eq(0)
        else:
            m.d.comb += self.misa_ok.eq(1)

        m.d.comb += self.spec_valid.eq(self.rvfi_valid & (~self.insn_padding) & (self.insn_opcode == self.opcode))
        m.d.comb += self.spec_rd_addr.eq(self.insn_rd)
        m.d.comb += self.spec_pc_wdata.eq(self.rvfi_pc_rdata + 4)

        return m
