let
  pkgs = import <nixpkgs> { };
  nmigen-latest = pkgs.python3Packages.nmigen.overrideAttrs(oa: {
    src = pkgs.fetchFromGitHub {
      owner = "m-labs";
      repo = "nmigen";
      rev = "1ad6e3207f02e913407867dddddb8f50fad0ced4";
      sha256 = "14vvw1lcfmcf3374wpn3sslgvgcfg18rkbs8x45vycqag6a5zy0b";
    };
  });
  minerva-latest = pkgs.python3Packages.buildPythonPackage {
    name = "minerva";
    
    src = pkgs.fetchFromGitHub {
      owner = "lambdaconcept";
      repo = "minerva";
      rev = "714d83530c81a681fe414b835564ab09acb10cb7";
      sha256 = "0s4mq05n8k25amisak4yr6nwndm4czmvzp06fjk1bmg6xzb2jf1a";
    };
    
    nativeBuildInputs = [ nmigen-latest pkgs.yosys pkgs.symbiyosys ];
  };
in
 pkgs.mkShell {
    buildInputs = [
      (pkgs.python3.withPackages(ps: [nmigen-latest]))
      pkgs.yosys pkgs.symbiyosys minerva-latest
    ];
  }
